'CxTranslator.vb
'Copyright  2001-2005 Easy Math Solution. All Rights Reserved
'http://www.e-MathSolution.com
'For details contact us: info@e-MathSolution.com

Imports System.Runtime.InteropServices
Namespace EMS

    <StructLayoutAttribute(LayoutKind.Sequential)> _
    Public Structure Complex
        Public re As Double
        Public im As Double
    End Structure

    Public Class CxTranslator
        <DllImport("CxTranslator.dll", CallingConvention:=CallingConvention.StdCall, _
      CharSet:=CharSet.Ansi)> _
        Public Shared Function EvaluateEqu(ByVal exp As String, ByRef args As Complex) As Complex
        End Function
        <DllImport("CxTranslator.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Ansi)> _
               Public Shared Function Evaluate(ByVal arg As String, ByVal exp As String, ByRef args As Complex) As Complex
        End Function
        <DllImport("CxTranslator.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Ansi)> _
                Public Shared Sub BuildEqu(ByVal arg As String)
        End Sub
        <DllImport("CxTranslator.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Ansi)> _
             Public Shared Sub Build(ByVal arg As String, ByVal exp As String)
        End Sub
        <DllImport("CxTranslator.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Ansi)> _
          Public Shared Function CalcFor(ByRef args As Complex) As Complex
        End Function


        Public Delegate Function CallBackUserFunction(ByRef val As Complex) As Complex
        <DllImport("CxTranslator.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Ansi)> _
         Public Shared Function AddFunction(ByVal fnName As String, ByVal lpFunc As CallBackUserFunction) As Boolean
        End Function
        <DllImport("CxTranslator.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Ansi)> _
         Public Shared Function RemoveFunction(ByVal fnName As String) As Boolean
        End Function

        <DllImport("CxTranslator.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Ansi)> _
            Public Shared Function AddConst(ByVal constName As String, ByVal val As Complex) As Boolean
        End Function
        <DllImport("CxTranslator.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Ansi)> _
         Public Shared Function RemoveConst(ByVal constName As String) As Boolean
        End Function

        Public Delegate Sub CallBackDelegate(ByVal constName As String)
        <DllImport("CxTranslator.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Ansi)> _
            Public Shared Sub SetErrorHandle(ByVal errDgt As CallBackDelegate)
        End Sub


        Public Sub SetEquTranslatorException()
            Dim errD As CallBackDelegate
            errD = New CallBackDelegate(AddressOf RiseException)
            SetErrorHandle(errD)
        End Sub

        Private Sub RiseException(ByVal err As String)
            Throw New Exception(err)
        End Sub

    End Class


    '//////////////////////////////////////////////////////////////////////////////////
    '//The UNICODE implementation of the CxTranslator algorithm
    Public Class CxTranslatorW
        <DllImport("CxTranslatorW.dll", CallingConvention:=CallingConvention.StdCall, _
                  CharSet:=CharSet.Unicode)> _
               Public Shared Function EvaluateEqu(ByVal exp As String, ByRef args As Complex) As Complex
        End Function
        <DllImport("CxTranslatorW.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Unicode)> _
               Public Shared Function Evaluate(ByVal arg As String, ByVal exp As String, ByRef args As Complex) As Complex
        End Function
        <DllImport("CxTranslatorW.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Unicode)> _
                Public Shared Sub BuildEqu(ByVal arg As String)
        End Sub
        <DllImport("CxTranslatorW.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Unicode)> _
             Public Shared Sub Build(ByVal arg As String, ByVal exp As String)
        End Sub
        <DllImport("CxTranslatorW.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Unicode)> _
          Public Shared Function CalcFor(ByRef args As Complex) As Complex
        End Function


        Public Delegate Function CallBackUserFunction(ByRef val As Complex) As Complex
        <DllImport("CxTranslatorW.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Unicode)> _
         Public Shared Function AddFunction(ByVal fnName As String, ByVal lpFunc As CallBackUserFunction) As Boolean
        End Function
        <DllImport("CxTranslatorW.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Unicode)> _
         Public Shared Function RemoveFunction(ByVal fnName As String) As Boolean
        End Function

        <DllImport("CxTranslatorW.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Unicode)> _
            Public Shared Function AddConst(ByVal constName As String, ByVal val As Complex) As Boolean
        End Function
        <DllImport("CxTranslatorW.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Unicode)> _
         Public Shared Function RemoveConst(ByVal constName As String) As Boolean
        End Function

        Public Delegate Sub CallBackDelegate(ByVal constName As String)
        <DllImport("CxTranslatorW.dll", CallingConvention:=CallingConvention.StdCall, _
            CharSet:=CharSet.Unicode)> _
            Public Shared Sub SetErrorHandle(ByVal errDgt As CallBackDelegate)
        End Sub


        Public Sub SetEquTranslatorException()
            Dim errD As CallBackDelegate
            errD = New CallBackDelegate(AddressOf RiseException)
            SetErrorHandle(errD)
        End Sub

        Private Sub RiseException(ByVal err As String)
            Throw New Exception(err)
        End Sub

    End Class


End Namespace

